/************************************************************
 *  Martin Toepfer     ***     PROJECT : Lingvisto          *
 *  Wissmannstr. 5     ***                                  *
 *  D - 22041 Hamburg  ***     File    : sig.c              *
 *  Germany            ***     Date    : 04.04.1997         *
 ************************************************************/
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include "datastructure.h"
#include "edit.h"
#include "file.h"
#include "sig.h"
#include "test.h"

/************************************************************
 *          global variables (in datastructure.c)           *
 ************************************************************/
extern struct lvo_file head;

/************************************************************
 * lvo_term : terminate Lingvisto, try to save changes and  *
 *            to destroy the datastructure                  *
 *                                                          *
 * signo : number of catched signal                         *
 ************************************************************/
/* ARGSUSED */
static void lvo_term(int signo) {
  restore_list();
  if (get_state() == CHANGED) {      /* try to save changes */
    set_filename(tmpnam(NULL));
    if (save_file() != 0)         /* unable to save changes */
      fprintf(stderr, "\a");
  }
  delete_all();                    /* destroy datastructure */
  free(head.filename);
  free(head.filename_bak);
  exit(signo);
}

/************************************************************
 * sig_init : initialize SIGNAL-handler                     *
 ************************************************************/
void init_sig(void) {
  signal(SIGABRT, SIG_IGN);              /* ignore SIGABRT */
  signal(SIGINT, SIG_IGN);               /* ignore SIGINT  */
  signal(SIGQUIT, SIG_IGN);              /* ignore SIGQUIT */
  signal(SIGTERM, lvo_term);       /* SIGTERM -> terminate */
}
